#####################################################################
# make WINUI=1

# don't create gamelist.txt
TEXTS = gamelist.txt

OBJDIRS += $(OBJ)/ui

# only OS specific output files and rules
OSOBJS += \
        $(OBJ)/ui/MAME32.o \
        $(OBJ)/ui/M32Util.o \
        $(OBJ)/ui/DirectInput.o \
        $(OBJ)/ui/DIJoystick.o \
        $(OBJ)/ui/DirectDraw.o \
        $(OBJ)/ui/file.o \
        $(OBJ)/ui/Directories.o \
        $(OBJ)/ui/mzip.o \
        $(OBJ)/ui/audit32.o \
        $(OBJ)/ui/ColumnEdit.o \
        $(OBJ)/ui/Screenshot.o \
        $(OBJ)/ui/TreeView.o \
        $(OBJ)/ui/Splitters.o \
        $(OBJ)/ui/Bitmask.o \
        $(OBJ)/ui/DataMap.o \
        $(OBJ)/ui/dxdecode.o \
        $(OBJ)/ui/Win32ui.o \
        $(OBJ)/ui/Properties.o \
        $(OBJ)/ui/ChildOutputStream.o \
        $(OBJ)/ui/options.o \
        $(OBJ)/ui/help.o


# add resource file
OSOBJS += $(OBJ)/ui/mame32.res

#####################################################################
# compiler

#
# Preprocessor Definitions
#

DEFS += \
        -DWINUI=1 \
        -DMAMENAME=\"MAME\" \
        -DDIRECTSOUND_VERSION=0x0300 \
        -DDIRECTINPUT_VERSION=0x0500 \
        -DDIRECTDRAW_VERSION=0x0300 \
        -DWINVER=0x0400 \
        -D_WIN32_IE=0x0400 \
        -D_WIN32_WINNT=0x0400 \
        -DWIN32 \
        -UWINNT \
        -DCLIB_DECL=__cdecl \
        -DDECL_SPEC= \
        -DZEXTERN=extern

ifneq ($(USE_EXTRA_FOLDER),)
DEFS += -DEXTRA_FOLDER
endif

ifneq ($(USE_CPUSND_FOLDER),)
DEFS += -DCPUSND_FOLDER
endif

ifneq ($(USE_CPS_FOLDER),)
DEFS += -DCPS_FOLDER
endif

#####################################################################
# Resources

RCDEFS = -DNDEBUG -D_WIN32_IE=0x0400

ifneq ($(USE_2XSAIMODE),)
RCDEFS += -DUSE_2XSAIMODE
endif

ifneq ($(USE_CPS_FOLDER),)
RCDEFS += -DCPS_FOLDER
endif

ifneq ($(USE_MSVC_RC),)
RCFLAGS = -i src/ui /l 0x409
else
RCFLAGS = -O coff --include-dir src/ui
endif

$(OBJ)/ui/%.res: src/ui/%.rc
	@echo Compiling resources $<...
ifneq ($(USE_MSVC_RC),)
	rc.exe $(RCDEFS) $(RCFLAGS) /Fo$(OBJ)/ui/xxx.tmp $<
	windres -i $(OBJ)/ui/xxx.tmp -I res -o $(OBJ)/ui/mame32.res -O coff
else
	@windres2.exe $(RCDEFS) $(RCFLAGS) -o $@ -i $<
endif

#####################################################################
# Linker

LIBS += -lkernel32 \
        -lshell32 \
        -lcomctl32 \
        -lcomdlg32 \
        -ladvapi32 \
        -lhtmlhelp

# use -mconsole for romcmp
LDFLAGS += -mwindows

#####################################################################

