# only Windows specific output files and rules
# the first two targets generate the prefix.h header
# note this requires that OSOBJS be the first target
#
OSOBJS = $(OBJ)/windows/winmain.o $(OBJ)/windows/fileio.o $(OBJ)/windows/config.o \
	 $(OBJ)/windows/ticker.o $(OBJ)/windows/fronthlp.o $(OBJ)/windows/video.o \
	 $(OBJ)/windows/input.o $(OBJ)/windows/sound.o $(OBJ)/windows/blit.o \
	 $(OBJ)/windows/snprintf.o $(OBJ)/windows/rc.o $(OBJ)/windows/misc.o \
	 $(OBJ)/windows/window.o $(OBJ)/windows/winddraw.o $(OBJ)/windows/asmblit.o \
	 $(OBJ)/windows/asmtile.o

# compile mamew w/ DX8
DEFS+= \
        -DDIRECTSOUND_VERSION=0x0300 \
        -DDIRECTINPUT_VERSION=0x0500 \
        -DDIRECTDRAW_VERSION=0x0300

ifneq ($(USE_DX8),)
DEFS += -DDX_SDK=8
endif

ifneq ($(USE_2XSAIMODE),)
OSOBJS += $(OBJ)/windows/2xsaiw.o $(OBJ)/windows/2xsaiwin.o 
DEFS += -DUSE_2XSAIMODE
endif

ifneq ($(USE_DIRECT3D_EFFECT),)
DEFS += -DUSE_DIRECT3D_EFFECT
OSOBJS += $(OBJ)/windows/winddraw7.o 
endif

# uncomment this line to enable guard pages on all memory allocations
#OSOBJS += $(OBJ)/windows/winalloc.o

# video blitting functions
$(OBJ)/windows/asmblit.o: src/windows/asmblit.asm
	@echo Assembling $<...
	$(ASM) -o $@ $(ASMFLAGS) $(subst -D,-d,$(ASMDEFS)) $<

# tilemap blitting functions
$(OBJ)/windows/asmtile.o: src/windows/asmtile.asm
	@echo Assembling $<...
	$(ASM) -o $@ $(ASMFLAGS) $(subst -D,-d,$(ASMDEFS)) $<

$(OBJ)/windows/2xsaiw.o: src/windows/2xsaiw.asm
	@echo Assembling $<...
	$(ASM) -o $@ $(ASMFLAGS) $(subst -D,-d,$(ASMDEFS)) $<

# Can't compile with our CFLAGS
$(OBJ)/windows/2xsaiwin.o: src/windows/2xsaiwin.cpp
	@echo Compiling $<...
	$(CC) $(ARCH) -O3 -fomit-frame-pointer -fstrict-aliasing \
	-Wno-sign-compare \
	-Wshadow -Wstrict-prototypes -Wundef \
	-Wpointer-arith -Wbad-function-cast -Wcast-align -Waggregate-return \
	-c $< -o $@
#	-Wall -Werror -Wunused \

# add our prefix files to the mix
CFLAGS += -mwindows -include src/$(MAMEOS)/winprefix.h

# add the windows libaries
LIBS += -luser32 -lgdi32 -lddraw -ldsound -ldinput -ldxguid -lwinmm -llibintl

# due to quirks of using /bin/sh, we need to explicitly specify the current path
CURPATH = ./

ifneq ($(WINUI),)
include src/ui/ui.mak
endif
